<?php

// Adds new supported media types for upload : kml & gpx
function geoMimes($mimes)
{
	$mimes = array_merge($mimes, array(
		'kml' => 'application/octet-stream',
		'gpx' => 'application/octet-stream'
	));

	return $mimes;
}

// Add the new filter
if (function_exists('add_filter'))
{
	add_filter('upload_mimes', 'geoMines');
}

if ( is_admin() ){


	function geomap_admin_menu() {

		if (function_exists('add_options_page'))
		{
			add_options_page(
				'WP Geoportail ShortCode',
				'WP Geoportail ShortCode',
				'administrator',
				'WP-Geoportail-ShortCode',
				'WP_Geoportail_ShortCode_html_page'
			);
		}
	} //function

	if (function_exists('add_action'))
	{
		add_action('admin_menu', 'geomap_admin_menu');
	}
}//if

function WP_Geoportail_ShortCode_html_page() {

	// See if the user has posted us some information
	// If they did, this hidden field will be set to 'Y'

	if( isset($_POST['submit_hidden']) && $_POST['submit_hidden'] == 'Y' )
	{
	    // Read/Save Values 
	    $temp = $_POST['geomap_lat'];
	    update_option('geomap_lat', $temp );
	    
	    $temp = $_POST['geomap_lon'];
	    update_option('geomap_lon', $temp );
	    
	    $temp = $_POST['geomap_type'];
	    update_option('geomap_type', $temp );
	   
	    $temp = $_POST['geomap_territory'];
	    update_option('geomap_territory', $temp );
	 
	    $temp = $_POST['geomap_z'];
	    update_option('geomap_z', $temp );
	    
	    $temp = $_POST['geomap_w'];
	    update_option('geomap_w', $temp );
	    
	    $temp = $_POST['geomap_h'];
	    update_option('geomap_h', $temp );
	    
	    $temp = $_POST['geomap_key'];
	    update_option('geomap_key', $temp );

	    $temp = $_POST['geomap_apiVersion'];
	    update_option('geomap_apiVersion', $temp );

	    $temp = $_POST['geomap_layers_array'];
	    if($temp != "")
		    update_option('geomap_layers_array', $temp);

		 $temp = $_POST['geomap_builder'];
	    update_option('geomap_builder', $temp );
		
	    // Put an settings updated message on the screen
		?>
<div class="updated"><p><strong><?php _e('settings saved.', 'menu-test' ); ?></strong></p></div>
		<?php
	}

	render_config_form("Admin");
	
	if (get_option('geomap_key') != '' )
	{
	?>
	
	<script type="text/javascript"
				src="http://api.ign.fr/geoportail/api?key=<?php echo get_option('geomap_key'); ?>&includeEngine=false&">
	</script>

	<?php	
	}
	?>
		<script language="javascript">
			var API_KEY = "<?php echo get_option('geomap_key'); ?>";
			var LAYERS_ARRAY = "<?php echo get_option('geomap_layers_array') ?>";
			window.onload= function(){
				active_form(API_KEY,LAYERS_ARRAY);
			};
		</script>
		
		<input type="hidden" name="geomap_layers_array" id="geomap_layers_array" value="" />
		<p>
			<input type="submit" value="<?php _e('Save Changes') ?>" />
		</p>

	</form>
</div>

<?php

}

?>
