<?php
/*
Plugin Name: Geoportail-Shortcode beta
Description: Use API Geoportail in Wordpress
Version: 1.9.3
*/

include_once plugin_dir_path( __FILE__ ).'/Metabox.php';
include_once plugin_dir_path( __FILE__ ).'/Admin.php';
include_once plugin_dir_path( __FILE__ ).'/Install.php';
include_once plugin_dir_path( __FILE__ ).'/Common.php';

register_activation_hook(__FILE__,'WP_GPX_Maps_install'); 
register_deactivation_hook( __FILE__, 'WP_GPX_Maps_remove');


/******************************************************************************/
// geoportailme
/******************************************************************************/
function geoportailme($attr) {
global $post;
/******************************************************************************/
// default atts
	$attr = shortcode_atts(
			array(	
				'lat'			=> get_option("geomap_lat"), 
				'lon'			=> get_option("geomap_lon"),
				'id'	 		=> '',
				'type'			=> get_option("geomap_type"), // normal ou mini
				'layers_array' 		=> get_option("geomap_layers_array"),
				'territory'		=> get_option("geomap_territory"),
				'z' 			=> get_option("geomap_z"),
				'w' 			=> get_option("geomap_w"),
				'h' 			=> get_option("geomap_h"),
				'kml_array'		=> '',
				'gpx_array'		=> '',
				'wms' 			=> '',
				'wms_layer'		=> '',
				'wms_title' 		=> 'couche_wms',
				'key'			=> get_option('geomap_key'),
				'api_version'		=> get_option('geomap_apiVersion'),
				'geolocate'		=> 'false',
				'geotag'		=> 'false'
				), $attr);

/******************************************************************************/
	$post_id = $post->ID;
        $attr['id'] = 'geoportail_'. $post_id .'_'. $attr['id'];

	$returnme = '
		<style type="text/css">
				.entry-content img {max-width: 100000%; /* override */}

				div#'. $attr['id'] .' {
					background-color:white;
					background-image:url(http://api.ign.fr/geoportail/api/js/1.2/theme/geoportal/img/loading.gif);
					background-position:center center;
					background-repeat:no-repeat;
				}
		</style>
	';

/*************************************************************************/
	$returnme .= '
	  	<div id="' . $attr['id'] . '" style="width:' . $attr['w'] . 'px; height:' . $attr['h'] . 'px; "> </div>
	';
/******************************************************************************/
	$returnme .= '
		<!-- get the API configuration, without the API javascript : -->
    		<script type="text/javascript" src="http://api.ign.fr/geoportail/api?key=' .$attr['key'] . '&includeEngine=false&">
			<!--//--><![CDATA[//><!-- //--><!]]>
		</script>

		<script type="text/javascript">
			window.onload= function() {
					//options for creating viewer:
					var options= OpenLayers.Util.extend(
						{
							territory:"' . (($attr['territory']=='FFX')?'FXX' : $attr['territory'])  . '",
							mode:"' .$attr['type'] . '"
							//projection:"IGNF:GEOPORTALFXX",
							//displayProjection:"IGNF:RGF93G"
						},
						gGEOPORTALRIGHTSMANAGEMENT
					);

					var viewer= new Geoportal.Viewer.Default(
						"' .$attr['id'] . '",
						options
					);

					if (!viewer) {
						// problem ...
						OpenLayers.Console.error("Création de la carte échouée");
						return;
					}
					var map = viewer.getMap();
		';


/******************************************************************************/
// Avanced Layers

	$layers_array = preg_split("/;/",$attr['layers_array'],-1,PREG_SPLIT_NO_EMPTY);

	foreach( $layers_array as $layer )
	{
		if (gettype($layer)!==gettype(array()))
		{
			$layer = preg_split("/[\s|]+/",$layer,-1,PREG_SPLIT_NO_EMPTY);
		}
		
		if($layer[0] == "ortho")
		{
			$layer[0] = "ORTHOIMAGERY.ORTHOPHOTOS:WMSC";
		}
		if($layer[0] == "map")
                {
                        $layer[0] = "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC";
                }
		
		$visibility = 1;
		$opacity = 1;
		
		if (count($layer) >= 2)
                {
			if($layer[1] == 'on')
                		$visibility =1;
			else
			        $visibility =0;

                }
                if (count($layer) >= 3)
                {
                	$opacity = $layer[2];
                }
                $returnme .= '
			viewer.addGeoportalLayers(
				["' . $layer[0]. '"],
				{
					"' . $layer[0]. '":{
						opacity:' . $opacity . ',
						visibility:' . $visibility . '
					}
				}
				
			);
                 ';
        }

/******************************************************************************/
//Center Map
	$returnme .= '
					map.setCenterAtLonLat(
						' . $attr['lon'] . ',
						' . $attr['lat'] . ',
						' . $attr['z'] . '
					);
		';
/******************************************************************************/
//kml_array
		if($attr['kml_array'] != '') 
		{
			if (gettype($attr['kml_array'])!==gettype(array()))
			{
				$attr['kml_array'] = preg_split("/;/",$attr['kml_array'],-1,PREG_SPLIT_NO_EMPTY);
			}
			foreach( $attr['kml_array'] as $kml )
			{
				if (gettype($kml)!==gettype(array()))
				{
					$kml = preg_split("/,/",$kml,-1,PREG_SPLIT_NO_EMPTY);
				}
				if (count($kml) == 1)
                                {
					$kml='KML_Layer';
			              //  $returnme .= '
                                      //          map.addLayer(
                                     //                   "KML",
                                      //                  "KML_Layer",
                                       //                 "' . $kml[0]. '",
                                       //                 {visibility:true, minZoomLevel:3, maxZoomLevel:16}
                                       //         );
                                       // ';
                                }
				if (count($kml) == 2)
				{
					$returnme .= '
						map.addLayer(
							"KML",
							"' . $kml[1] . '",
							"' . $kml[0]. '",
							{visibility:true, minZoomLevel:3, maxZoomLevel:16}
						);
					';	
				}
			}
		}

/******************************************************************************/
//gpx_array
		if($attr['gpx_array'] != '') 
		{
			if (gettype($attr['gpx_array'])!==gettype(array()))
			{
				$attr['gpx_array'] = preg_split("/;/",$attr['gpx_array'],-1,PREG_SPLIT_NO_EMPTY);
			}
			foreach( $attr['gpx_array'] as $gpx )
			{
				if (gettype($gpx)!==gettype(array()))
				{
					$gpx = preg_split("/,/",$gpx,-1,PREG_SPLIT_NO_EMPTY);
				
				}
				if (count($gpx) == 1)
                                {
					$gpx[]='GPX_Layers';
                                        //$returnme .= '
                                        //        map.addLayer(
                                        //                "GPX",
                                        //                "GPX_Layer",
                                        //               "' . $gpx[0]. '",
                                        //                {visibility:true, minZoomLevel:3, maxZoomLevel:16}
                                        //        );
                                        //';
                                }
				if (count($gpx) == 2)
				{
					$returnme .= '
						map.addLayer(
							"GPX",
							"' . $gpx[1] . '",
							"' . $gpx[0]. '",
							{
								visibility:true,
								minZoomLevel:1,
								maxZoomLevel:16,
								styleMap: new OpenLayers.StyleMap({
									strokeColor: "blue",
									strokeWidth: 5,
									strokeOpacity: 0.8,
									fillOpacity: 0.2,
									fillColor: "blue"
								})
							}
						);
					';	
				}
			}

		}
		
/******************************************************************************/
//wms
		if($attr['wms'] != '') 
		{
			$returnme .= '
					map.addLayer(
						"WMS",
						"' . $attr['wms_title'] . '",
						"' . $attr['wms'] . '",
	                		   	{layers: "' . $attr['wms_layer'] . '"},
		                   		{transitionEffect: "resize"}	
					);
			';
		}
/******************************************************************************/
//geolocate
	if($attr['geolocate'] != 'false')
	{
		$returnme .= '
					var geolocate = new OpenLayers.Control.Geolocate({
						bind: true,
						geolocationOptions: {
							enableHighAccuracy: false,
							maximumAge: 0,
							timeout: 7000
						}
					});
					map.addControl(geolocate);

					var pulsate = function(feature) {
					var point = feature.geometry.getCentroid(),
					    bounds = feature.geometry.getBounds(),
					    radius = Math.abs((bounds.right - bounds.left)/2),
					    count = 0,
					    grow = "up";

					var resize = function(){
					        if (count>16) {
					            clearInterval(window.resizeInterval);
        					}
					        var interval = radius * 0.03;
					        var ratio = interval/radius;
					        switch(count) {
					            case 4:
					            case 12:
				        	        grow = "down"; break;
					            case 8:
					                grow = "up"; break;
					        }
					        if (grow!=="up") {
					            ratio = - Math.abs(ratio);
				        	}
					        feature.geometry.resize(1+ratio, point);
					        vector.drawFeature(feature);
					        count++;
					    };
				    	window.resizeInterval = window.setInterval(resize, 50, point, radius);
					};

					var vector = new OpenLayers.Layer.Vector("myLocation");
					map.addLayers([vector]);

					geolocate.events.register("locationupdated",geolocate,function(e) {
						map.setCenterAtLonLat(
                                                	e.point.x,
                                              		e.point.y,
                                                	' . $attr['z'] . '
                                        	);
						vector.removeAllFeatures();
						var circle = new OpenLayers.Feature.Vector(
						        OpenLayers.Geometry.Polygon.createRegularPolygon(
						            new OpenLayers.Geometry.Point(e.point.x, e.point.y),
						            e.position.coords.accuracy/2,
            							40,
            							0
        						),
        						{},
        						{
							    fillColor: "#000",
							    fillOpacity: 0.1,
							    strokeWidth: 0
							}
						   );
						vector.addFeatures([
						        new OpenLayers.Feature.Vector(
						            e.point,
							    {},
						            {
						                graphicName: "cross",
						                strokeColor: "#f00",
						                strokeWidth: 2,
						                fillOpacity: 0,
						                pointRadius: 10
						            }
						        ),
						        circle
						    ]);
						pulsate(circle);
					});
					geolocate.activate();
		';
	}

/******************************************************************************/
//geotags
	if($attr['geotag'] != 'false')
	{
		$post_id = $post->ID;
		$lon = get_post_meta($post_id, 'geo_longitude', true);
		$lat = get_post_meta($post_id, 'geo_latitude', true);
		// geo_public geo_enabled
		$geo_public = get_post_meta($post_id, 'geo_public', true);
		$geo_enabled = get_post_meta($post_id, 'geo_enabled', true);
		if ($geo_public == '1' && $geo_enabled =='1')
		{
			$returnme .= '
				map.setCenterAtLonLat('. $lon .','. $lat .',10);
			';
		}
	}
 
/******************************************************************************/
	$returnme .= '
		     		};//function;

		</script>
		';

	$returnme .= '		
		<script type="text/javascript"  src="http://api.ign.fr/geoportail/api/js/' .$attr['api_version'] . '/GeoportalExtended.js"> <!-- --></script>
		';

/******************************************************************************/
	return $returnme;
}

add_shortcode('geoportail', 'geoportailme');


?>
